var dCellMark = new Array("one", "two", "three", "four", "five",
						  "six", "seven", "eight", "nine");

var dCellClosed        = 0;
var dCellOpened        = 1;
var dCellFlag          = 2;
var dCellBomb          = -1;
var dMaxCellWidth      = 30;
var dMaxCellHeight     = 30;
var dDefaultCellWidth  = 10;
var dDefaultCellHeight = 10;
var dDefaultBombs      = 10;

var gWidth;
var gHeight;
var gBombs;

var gCell;
var gCellStat;
var gCellElement;
var gOpenCellCount;
var gGameOver;

var gHorizonalMargin  = 40;
var gVerticalMargin   = 70;
var gButtonHeight     = 25;

var gFrontWinWidth;
var gFrontWinHeight;

var gGameStartTime;

var gBombImage;
var gSafeBombImage;


function setup() {
	var w = 10;
	var h = 10;
	var b = 10;

	// image cache
	gBombImage = new Image(18, 18);
	gBombImage.src = "images/bomb.png";
	gSafeBombImage = new Image(18, 18);
	gSafeBombImage.src = "images/bomb-safe.png";
	gFlagImage = new Image(18, 18);
	gFlagImage.src = "images/flag.png";
	
	if (window.widget) {
		w = widget.preferenceForKey("width");
		h = widget.preferenceForKey("height");
		b = widget.preferenceForKey("bombs");

		if (! w || w > dMaxCellWidth) {
			w = dDefaultCellWidth;
		}
		if (! h || w > dMaxCellHeight) {
			h = dDefaultCellHeight;
		}
		if (! b) {
			b = dDefaultBombs;
		}
	}
	set_width(w);
	set_height(h);
	set_bombs(b);
	
	reset_cell();
}

function setup_back () {
	showPrefs();
	window.resizeTo(220, 145);
}

function reset_preference () {
	var width  = get_width();
	var height = get_height();
	
	set_width(width);
	set_height(height);
	set_bombs(get_bombs());
	window.resizeTo(gFrontWinWidth, gFrontWinHeight);
	hidePrefs();
	return true;
}

function update_preference () {
	var width  = document.getElementById("width").value;
	var height = document.getElementById("height").value;
	var bombs  = document.getElementById("bombs").value;

	if (0 >= width) {
		set_back_status("width must grater than 1");
		return false;
	}
	if (0 >= height) {
		set_back_status("height must grater than 1");
		return false;
	}
	if (bombs > width * height) {
		set_back_status("Too much bombs!");
		return false;
	}
	if (0 >= bombs) {
		set_back_status("bombs must grater than 1");
		return false;
	}
	if (dMaxCellWidth < width) {
		set_back_status("width must less than " + dMaxCellWidth);
		return false;
	}
	if (dMaxCellHeight < height) {
		set_back_status("height must less than " + dMaxCellHeight);
		return false;
	}

	set_width(width);
	set_height(height);
	set_bombs(bombs);

	hidePrefs();
	reset_cell();
	return;
}
function update_preference_check () {
	return;
}



//
// reset minesweeper board
//
function reset_cell (ev) {
	var bombs    = get_bombs();
	var height   = get_height();
	var width    = get_width();
	var cellLen  = width * height;
	var bombNum  = document.getElementById("BombNum");
	var restNum  = document.getElementById("RestNum");
	var i;
	gGameOver      = 0;
	gOpenCellCount = 0;
	gCellStat      = new Array();
	gCell          = new Array();
	gCellElement   = new Array();

	if (ev && true == ev.shiftKey) {
		// click with Shift
		// -- reset to System Default
		set_width(dDefaultCellWidth);
		set_height(dDefaultCellHeight);
		set_bombs(dDefaultBombs);
		width  = get_width();
		height = get_height();
		bombs  = get_bombs();
		cellLen = width * height;
	}

	// set window
	reset_front_status();
	reset_back_status();
	set_board_size(width, height);

	// init cell
	for (i = 0; i < cellLen; i++) {
		var action = "return click_cell(event, " + i + ");";
		gCell[i] = 0;
		gCellStat[i] = dCellClosed;
		gCellElement[i] = document.createElement("li");
		gCellElement[i].setAttribute("onclick", action);
		gCellElement[i].setAttribute("oncontextmenu", action);
	}

	// set bombs
	for (i = 0; i < bombs;) {
		var point = Math.floor(Math.random() * cellLen);
		if (-1 != gCell[point]) {
			gCell[point] = -1;
			i++;
		}
	}

	// init bomb counts
	for (i = 0; i < cellLen; i++) {
		var count = 0;

		if (-1 != gCell[i]) {
			var target;
			// has left
			if (1 != (i + 1) % width) {
				// top
				if (i + 1 > width) {
					target = i - width - 1;
					if (-1 == gCell[target]) {
						count++;
					}
				}
				// middle
				target = i - 1;
				if (-1 == gCell[target]) {
					count++;
				}
				// bottom
				if (i + 1 <= (height - 1) * width) {
					target = i + width - 1;
					if (-1 == gCell[target]) {
						count++;
					}
				}
			}
			// has right
			if (0 != (i + 1) % width) {
				// top
				if (i + 1 > width) {
					target = i - width + 1;
					if (-1 == gCell[target]) {
						count++;
					}
				}
				// middle
				target = i + 1;
				if (-1 == gCell[target]) {
					count++;
				}
				// bottom
				if (i + 1 <= (height - 1) * width) {
					target = i + width + 1;
					if (-1 == gCell[target]) {
						count++;
					}
				}
			}
			// top
			if (i + 1 > width) {
				target = i - width;
				if (-1 == gCell[target]) {
					count++;
				}
			}
			// bottom
			if (i + 1 <= (height - 1) * width) {
				target = i + width;
				if (-1 == gCell[target]) {
					count++;
				}
			}
			gCell[i] = count;
		}
	}

	// create elements
	for (i = 0; i < cellLen; i++) {
		var text = document.createTextNode(" ");
		gCellElement[i].appendChild(text);
	}
	
	var board = get_board();
	
	board = remove_all_child(board);
	for (i = 0; i < gCellElement.length; i++) {
		board.appendChild(gCellElement[i]);
	}

	// update status
	var rest = (gCell.length - get_bombs()).toString();
	bombNum.firstChild.data = get_bombs();
	restNum.firstChild.data = rest + " / " + rest;
	return 1;
}



function click_cell (ev, cellNum) {
	cellNum = cellNum * 1;
	if (! gOpenCellCount) {
		gGameStartTime = new Date();
	}
	if (gGameOver) {
		return; // already game over
	}
	if (dCellOpened == gCellStat[cellNum]) {
		return; // already opened
	}

	//
	// check mousebutton
	//
	if (2         == ev.button          ||
		true      == ev.ctrlKey         ||
		true      == ev.shiftKey        ||
		dCellFlag == gCellStat[cellNum]) {
		// right click or CTRL + click or already Flagged
		toggle_flag(cellNum);
	} else {
		// left click
		open_cell(cellNum);
	}
	
	return false; // don't open context menu
}
	
function toggle_flag (cellNum) {
	var board = document.getElementById("MineSweeper");
	var cell = board.childNodes[cellNum];
	var cellData;

	if (dCellFlag == gCellStat[cellNum]) {
		// take down flag
		cellData = document.createTextNode(" ");
		gCellStat[cellNum] = dCellClosed;
	} else {
		// take up flag
		cellData = document.createElement("img");
		cellData.setAttribute("src",    "images/flag.png");
		cellData.setAttribute("width",  "18");
		cellData.setAttribute("height", "18");
		cellData.setAttribute("alt",    "F");
		gCellStat[cellNum] = dCellFlag;
	}
	
	cell = remove_all_child(cell);
	cell.appendChild(cellData);
}

function open_cell (cellNum) {
	if (-1 == gCell[cellNum]) {
		// is BOMB!
		game_over();
		return;
	} else {
		// none
		var restNum  = document.getElementById("RestNum");
		var rest;
		var total;
		
		_open_cell(cellNum);
		if (0 == gCell[cellNum]) {
			open_arround_cell(cellNum);
		}
		total = (gCell.length - get_bombs()).toString();
		rest = (gCell.length - get_bombs() - gOpenCellCount).toString();
		restNum.firstChild.data = rest + " / " + total;
		if (gOpenCellCount == gCell.length - get_bombs()) {
			game_clear();
		}
		return;
	}
}
function _open_cell (cellNum, bombPath) {
	var board = document.getElementById("MineSweeper");
	var cell = board.childNodes[cellNum];
	var oldChild = cell.childNodes;
	var cellData = open_panel_element(gCell[cellNum], bombPath);
	var cellClass;

	gOpenCellCount++;
	gCellStat[cellNum] = dCellOpened;
	if (0 < gCell[cellNum]) {
		cellClass = " " + dCellMark[gCell[cellNum] - 1];
	}

	cell = remove_all_child(cell);
	cell.appendChild(cellData);
	if (cellClass) {
		cell.setAttribute("class", "open" + cellClass);
	} else {
		cell.setAttribute("class", "open");
	}
}
function open_arround_cell (cellNum) {
	var width  = get_width();
	var height = get_height();
	var cellList = new Array();

	cellList[0] = cellNum;
	while (cellList.length) {
		cell = cellList[cellList.length - 1];
		// has left cell
		if (1 != (cell + 1) % width) {
			var target;
			// top
			if (cell + 1 > width) {
				target = cell - width - 1;
				if (dCellClosed == gCellStat[target]) {
					_open_cell(target);
					if (0 == gCell[target]) {
						cellList.push(target);
						continue;
					}
				}
			}
			// middle
			target = cell - 1;
			if (dCellClosed == gCellStat[target]) {
				_open_cell(target);
				if (0 == gCell[target]) {
					cellList.push(target);
					continue;
				}
			}
			// bottom
			if (cell + 1 <= (height - 1) * width) {
				target = cell + width - 1;
				if (dCellClosed ==  gCellStat[target]) {
					_open_cell(target);
					if (0 == gCell[target]) {
						cellList.push(target);
						continue;
					}
				}
			}
		}
		// has right cell
		if (0 != (cell + 1) % width) {
			var target;
			// top
			if (cell + 1 > width) {
				target = cell - width + 1;
				if (dCellClosed == gCellStat[target]) {
					_open_cell(target);
					if (0 == gCell[target]) {
						cellList.push(target);
						continue;
					}
				}
			}
			// middle
			target = cell + 1;
			if (dCellClosed == gCellStat[target]) {
				_open_cell(target);
				if (0 == gCell[target]) {
					cellList.push(target);
					continue;
				}
			}
			// bottom
			if (cell + 1 <= (height - 1) * width) {
				target = cell + width + 1;
				if (dCellClosed == gCellStat[target]) {
					_open_cell(target);
					if (0 == gCell[target]) {
						cellList.push(target);
						continue;
					}
				}
			}
		}
		// top
		if (cell + 1 > width) {
			var target = cell - width;
			if (dCellClosed == gCellStat[target]) {
				_open_cell(target);
				if (0 == gCell[target]) {
					cellList.push(target);
					continue;
				}
			}
		}
		// botton
		if (cell + 1 <= (height - 1) * width) {
			var target = cell + width;
			if (dCellClosed == gCellStat[target]) {
				_open_cell(target);
				if (0 == gCell[target]) {
					cellList.push(target);
					continue;
				}
			}
		}
		cellList.pop();
	}
	return;
}

function game_over () {
	var i;
	var max = get_width() * get_height();
	
	for (i = 0; i < max; i++) {
		if (dCellFlag == gCellStat[i]) {
			if (dCellBomb != gCell[i]) {
				// mistake flag
				var board = document.getElementById("MineSweeper");
				var cell = board.childNodes[i];
				var cellData;
				cellData = document.createElement("img");
				cellData.setAttribute("src",    "images/flag-ng.png");
				cellData.setAttribute("width",  "18");
				cellData.setAttribute("height", "18");
				cellData.setAttribute("alt",    "X");
				cell = remove_all_child(cell);
				cell.appendChild(cellData);
			}
		} else {
			_open_cell(i);
		}
	}
	set_front_status("Game Over!");
	gGameOver = 1;
	return;
}

function game_clear () {
	var endTime = new Date();
	var timeDiff = (endTime.getTime() - gGameStartTime.getTime()) / 1000;
	var timeDiffMin = Math.floor(timeDiff / 60);
	var timeDiffSec = timeDiff - (timeDiffMin * 60);
	var timeDiffStr;
	var i;
	var max = get_width() * get_height();

	// open bombs
	for (i = 0; i < max; i++) {
		if (dCellFlag != gCellStat[i]) {
			_open_cell(i, "images/bomb-safe.png");
		}
	}
	
	timeDiffSec = Math.floor(timeDiffSec * 100) / 100;
	if (timeDiffSec < 10.0) {
		timeDiffSec = "0" + timeDiffSec.toString();
	}
	timeDiffStr = timeDiffMin.toString() + ":" + timeDiffSec;
	
	//	set_front_status("Congratulations!");
	set_front_status(timeDiffStr);
	gGameOver = 1;
}

function open_panel_element (status, bombPath) {
	var node = document.createTextNode("");
	
	if (! bombPath) {
		bombPath = "images/bomb.png";
	}
		
	switch (status) {
	case -1: // BOMB
		node = document.createElement("img");
		node.setAttribute("src",    bombPath);
		node.setAttribute("width",  "18");
		node.setAttribute("height", "18");
		node.setAttribute("alt", "*");
		break;
	case 0: // NONE
		node.data = " ";
		break;
	case 1:
		node.data = "1";
		break;
	case 2:
		node.data = "2";
		break;
	case 3:
		node.data = "3";
		break;
	case 4:
		node.data = "4";
		break;
	case 5:
		node.data = "5";
		break;
	case 6:
		node.data = "6";
		break;
	case 7:
		node.data = "7";
		break;
	case 8:
		node.data = "8";
		break;
	}
	
	return node;
}

//
// manage board width
//
function set_board_size (width, height) {
	width  = width * 20;
	height = height * 20;
	var body      = document.getElementsByTagName("body")[0];
	var board     = document.getElementById("MineSweeper");
	var winWidth  = width + gHorizonalMargin;
	var winHeight = height + gVerticalMargin + gButtonHeight;
	
	
	board.setAttribute("style", "height: " + height + "px; " +
					            "width: " + width + "px; " +
					            "margin: 0 auto;");
	body.setAttribute("style", "width: " + winWidth + "px;");
	
	window.resizeTo(winWidth, winHeight);
	gFrontWinWidth  = winWidth;
	gFrontWinHeight = winHeight;

	// debug
	//set_front_status(winWidth.toString() + " x " + winHeight.toString());
	return;
}



//////////////////////////////////////////////////////////////////////
// manage status bar and error bar
//////////////////////////////////////////////////////////////////////
function set_front_status (status) {
	var text = document.createTextNode(status);
	var statusBar = document.getElementById("FrontStatusBar");
	statusBar = remove_all_child(statusBar);
	statusBar.appendChild(text);
}
function reset_front_status () {
	set_front_status("");
}
function reset_back_status () {
	set_back_status("");
}
function set_back_status (status) {
	var text = document.createTextNode(status);
	var errorBar = document.getElementById("BackStatusBar");
	errorBar = remove_all_child(errorBar);
	errorBar.appendChild(text);
}



//
// DOM utility
//
function remove_all_child (node) {
	while (node.firstChild) {
		node.removeChild(node.firstChild);
	}
	return node;
}

function get_board () {
	return document.getElementById("MineSweeper");
}



//
// get/set global variables
//
function set_width (width) {
	width *= 1;
	gWidth  = width;
	if (window.widget) {
		widget.setPreferenceForKey(width, "width");
	}
	document.getElementById("width").value = width;;
}
function set_height (height) {
	height *= 1;
	gHeight = height;
	if (window.widget) {
		widget.setPreferenceForKey(height, "height");
	}
	document.getElementById("height").value = height;
}
function set_bombs (bombs) {
	bombs *= 1;
	gBombs = bombs;
	if (window.widget) {
		widget.setPreferenceForKey(bombs, "bombs");
	}
	document.getElementById("bombs").value = bombs;
}

function get_height () {
	return gHeight;
}
function get_width () {
	return gWidth;
}
function get_bombs () {
	return gBombs;
}



//////////////////////////////////////////////////////////////////////
//
// exchange front/back (by Apple)
//
//////////////////////////////////////////////////////////////////////
function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToBack");
    front.style.display="none";
    back.style.display="block";
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToFront");
    back.style.display="none";
    front.style.display="block";
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}



//////////////////////////////////////////////////////////////////////
//
// Animate Info Button (by Apple)
//
//////////////////////////////////////////////////////////////////////
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
    T = limit_3(time-animation.starttime, 0, animation.duration);
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}